Index: c/src/lib/libbsp/i386/shared/irq/irq_asm.s
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq_asm.s	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
+++ c/src/lib/libbsp/i386/shared/irq/irq_asm.s	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -0,0 +1,261 @@
+/* irq.c
+ *
+ *  This file contains the implementation of the function described in irq.h
+ *
+ *  CopyRight (C) 1998 valette@crf.canon.fr
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include "asm.h"	
+#include <irq_asm.h>
+
+.set SAVED_REGS     , 32                   # space consumed by saved regs
+.set EIP_OFFSET     , SAVED_REGS           # offset of tasks eip
+.set CS_OFFSET      , EIP_OFFSET+4         # offset of tasks code segment
+.set EFLAGS_OFFSET  , CS_OFFSET+4          # offset of tasks eflags
+	
+
+/*PAGE
+ *  void _new_ISR_Displatch()
+ *
+ *  Entry point from the outermost interrupt service routine exit.
+ *  The current stack is the supervisor mode stack.
+ */
+
+        PUBLIC (_new_ISR_Displatch)
+SYM (_New_ISR_Displatch):
+
+        call      SYM (_Thread_Dispatch)   # invoke Dispatcher
+
+       /*
+        * BEGINNING OF DE-ESTABLISH SEGMENTS
+        *
+        *  NOTE:  Make sure there is code here if code is added to
+        *         load the segment registers.
+        *
+        */
+
+       /***** DE-ESTABLISH SEGMENTS CODE GOES HERE ****/
+
+       /*
+        * END OF DE-ESTABLISH SEGMENTS
+        */
+
+        popa                                # restore general registers
+        iret                                # return to interrupted thread
+
+		
+SYM (_New_ISR_Handler):	
+       /*
+        *  Before this was point is reached the vectors unique
+        *  entry point did the following:
+        *
+        *     1. saved sctach registers registers eax edx ecx"
+        *     2. put the vector number in ecx.
+        *
+        * BEGINNING OF ESTABLISH SEGMENTS
+        *
+        *  WARNING: If an interrupt can occur when the segments are
+        *           not correct, then this is where we should establish
+        *           the segments.  In addition to establishing the
+        *           segments, it may be necessary to establish a stack
+        *           in the current data area on the outermost interrupt.
+        *
+        *  NOTE:  If the previous values of the segment registers are
+        *         pushed, do not forget to adjust SAVED_REGS.
+        *
+        *  NOTE:  Make sure the exit code which restores these
+        *         when this type of code is needed.
+        */
+
+       /***** ESTABLISH SEGMENTS CODE GOES HERE  ******/
+
+       /*
+        * END OF ESTABLISH SEGMENTS
+        */
+
+        /*
+         *  Now switch stacks if necessary
+         */
+
+	movw	  SYM (i8259s_cache), ax # move current i8259 interrupt mask in ax
+	pushl	  eax			      # push it on the stack
+	/*
+	 * compute the new PIC mask:
+	 *
+	 * <new mask> = <old mask> | irq_mask_or_tbl[<intr number aka ecx>]
+	 */
+	movw	  SYM (irq_mask_or_tbl) (,ecx,2), dx
+	orw	  dx, ax
+	/*
+	 * Install new computed value on the i8259 and update cache
+	 * accordingly
+	 */
+	movw      ax, SYM (i8259s_cache)
+	outb	  $PIC_MASTER_IMR_IO_PORT
+	movb	  ah, al
+	outb	  $PIC_SLAVE_IMR_IO_PORT
+
+	/*
+	 * acknowledge the interrupt
+	 *
+	 */
+	movb	$PIC_EOI, al
+        cmpl    $7, ecx
+	jbe	.master
+	outb    $PIC_SLAVE_COMMAND_IO_PORT
+.master:
+        outb    $PIC_MASTER_COMMAND_IO_PORT
+	
+.check_stack_switch:
+	pushl	  ebp
+        movl      esp, ebp                  # ebp = previous stack pointer
+        cmpl      $0, SYM (_ISR_Nest_level) # is this the outermost interrupt?
+        jne       nested                    # No, then continue
+        movl      SYM (_CPU_Interrupt_stack_high), esp
+
+        /*
+         *  We want to insure that the old stack pointer is on the
+         *  stack we will be on at the end of the ISR when we restore it.
+         *  By saving it on every interrupt, all we have to do is pop it
+         *  near the end of every interrupt.
+         */
+
+nested:
+        incl      SYM (_ISR_Nest_level)     # one nest level deeper
+        incl      SYM (_Thread_Dispatch_disable_level) # disable multitasking
+	/*
+	 * re-enable interrupts at processor level as the current
+	 * interrupt source is now masked via i8259
+	 */
+	sti
+	
+        /*
+	 *  ECX is preloaded with the vector number but it is a scratch register
+	 *  so we must save it again.
+	 */
+	
+        pushl     ecx                       # push vector number
+        mov       SYM (current_irq) (,ecx,4),eax
+                                            # eax = Users handler
+        call      *eax                      # invoke user ISR
+	/*
+	 * disable interrupts_again
+	 */
+	cli
+        popl       ecx                       # ecx = vector number
+	/*
+	 * restore stack
+	 */
+	movl	  ebp, esp
+	popl	  ebp
+
+	/*
+	 * restore the original i8259 masks
+	 */
+	popl	  eax
+	movw      ax, SYM (i8259s_cache)
+	outb	  $PIC_MASTER_IMR_IO_PORT
+	movb	  ah, al
+	outb	  $PIC_SLAVE_IMR_IO_PORT
+	
+	
+        decl      SYM (_ISR_Nest_level)     # one less ISR nest level
+                                            # If interrupts are nested,
+                                            #   then dispatching is disabled
+
+        decl      SYM (_Thread_Dispatch_disable_level)
+                                            # unnest multitasking
+                                            # Is dispatch disabled
+        jne       .exit                     # Yes, then exit
+
+        cmpl      $0, SYM (_Context_Switch_necessary)
+                                            # Is task switch necessary?
+        jne       bframe                    # Yes, then build stack
+
+        cmpl      $0, SYM (_ISR_Signals_to_thread_executing)
+                                            # signals sent to Run_thread
+                                            #   while in interrupt handler?
+        je        .exit                     # No, exit
+
+bframe:
+        movl      $0, SYM (_ISR_Signals_to_thread_executing)
+	/*
+	 * complete code as if a pusha had been executed on entry
+	 */
+	pushl	  ebx
+	pushl	  esp
+	pushl	  ebp
+	pushl	  esi
+	pushl	  edi
+                                            # push the isf for Isr_dispatch
+        pushl     EFLAGS_OFFSET(esp)        # push tasks eflags
+        push      cs                        # cs of Isr_dispatch
+        pushl     $ SYM (_New_ISR_Displatch)# entry point
+        iret
+
+.exit:
+       /*
+        * BEGINNING OF DE-ESTABLISH SEGMENTS
+        *
+        *  NOTE:  Make sure there is code here if code is added to
+        *         load the segment registers.
+        *
+        */
+
+       /******* DE-ESTABLISH SEGMENTS CODE GOES HERE ********/
+
+       /*
+        * END OF DE-ESTABLISH SEGMENTS
+        */
+	popl	edx
+	popl	ecx
+	popl	eax
+	iret
+		
+#define DISTINCT_INTERRUPT_ENTRY(_vector) \
+        .p2align 4                         ; \
+        PUBLIC (rtems_irq_prologue_ ## _vector ) ; \
+SYM (rtems_irq_prologue_ ## _vector ):             \
+        pushl	eax		; \
+	pushl	ecx		; \
+	pushl	edx		; \
+	movl	$ _vector, ecx  ; \
+        jmp   SYM (_New_ISR_Handler) ;
+
+DISTINCT_INTERRUPT_ENTRY(0)
+DISTINCT_INTERRUPT_ENTRY(1)
+DISTINCT_INTERRUPT_ENTRY(2)
+DISTINCT_INTERRUPT_ENTRY(3)
+DISTINCT_INTERRUPT_ENTRY(4)
+DISTINCT_INTERRUPT_ENTRY(5)
+DISTINCT_INTERRUPT_ENTRY(6)
+DISTINCT_INTERRUPT_ENTRY(7)
+DISTINCT_INTERRUPT_ENTRY(8)
+DISTINCT_INTERRUPT_ENTRY(9)
+DISTINCT_INTERRUPT_ENTRY(10)
+DISTINCT_INTERRUPT_ENTRY(11)
+DISTINCT_INTERRUPT_ENTRY(12)
+DISTINCT_INTERRUPT_ENTRY(13)
+DISTINCT_INTERRUPT_ENTRY(14)
+DISTINCT_INTERRUPT_ENTRY(15)
+	
+	/*
+	 * routine used to initialize the IDT by default
+	 */
+		
+PUBLIC (default_raw_idt_handler)
+PUBLIC (raw_idt_notify)
+		
+SYM (default_raw_idt_handler):
+	pusha
+	cld
+	call	raw_idt_notify
+	popa
+	iret
+	
Index: c/src/lib/libbsp/i386/shared/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
+++ c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -0,0 +1,200 @@
+/* irq_init.c
+ *
+ *  This file contains the implementation of rtems initialization
+ *  related to interrupt handling.
+ *
+ *  CopyRight (C) 1998 valette@crf.canon.fr
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <libcpu/cpu.h>
+#include <irq.h>
+#include <bsp.h>
+
+/*
+ * rtems prologue generated in irq_asm.S
+ */
+extern void rtems_irq_prologue_0();
+extern void rtems_irq_prologue_1();
+extern void rtems_irq_prologue_2();
+extern void rtems_irq_prologue_3();
+extern void rtems_irq_prologue_4();
+extern void rtems_irq_prologue_5();
+extern void rtems_irq_prologue_6();
+extern void rtems_irq_prologue_7();
+extern void rtems_irq_prologue_8();
+extern void rtems_irq_prologue_9();
+extern void rtems_irq_prologue_10();
+extern void rtems_irq_prologue_11();
+extern void rtems_irq_prologue_12();
+extern void rtems_irq_prologue_13();
+extern void rtems_irq_prologue_14();
+extern void rtems_irq_prologue_15();
+/*
+ * default idt vector
+ */
+extern void default_raw_idt_handler();
+/*
+ * default on/off function
+ */
+static void nop_func(){}
+/*
+ * default isOn function
+ */
+static int not_connected() {return 0;}
+
+
+static rtems_raw_irq_connect_data 	idtHdl[IDT_SIZE];
+
+/*
+ * Table used to store rtems managed interrupt handlers.
+ * Borrow the table to store raw handler entries at the beginning.
+ * The table will be reinitialized before the call to pc386_rtems_irq_mngt_set().
+ */
+static rtems_irq_connect_data     	rtemsIrq[PC_386_IRQ_LINES_NUMBER] = {
+  {0,(rtems_irq_hdl)rtems_irq_prologue_0},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_1},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_2},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_3},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_4},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_5},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_6},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_7},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_8},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_9},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_10},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_11},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_12},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_13},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_14},
+  {0,(rtems_irq_hdl)rtems_irq_prologue_15}
+};
+
+static rtems_raw_irq_connect_data 	defaultRawIrq = {
+  /* vectorIdex,	 hdl			      , on	, off 		, isOn */
+  0, 			default_raw_idt_handler ,nop_func	, nop_func,	not_connected
+};
+
+static rtems_irq_connect_data     	defaultIrq = {
+  /* vectorIdex,	 hdl		, on		, off		, isOn */
+  0, 			 nop_func	, nop_func	, nop_func	, not_connected
+};
+
+static rtems_irq_prio irqPrioTable[PC_386_IRQ_LINES_NUMBER]={
+  /*
+   * actual rpiorities for interrupt :
+   *	0   means that only current interrupt is masked
+   *	255 means all other interrupts are masked
+   * The second entry has a priority of 255 because
+   * it is the slave pic entry and is should always remain
+   * unamsked.
+   */
+  0,0,
+  255,
+  0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0
+};
+    
+
+    
+static interrupt_gate_descriptor	idtEntry;
+
+static rtems_irq_global_settings     initial_config;
+static rtems_raw_irq_global_settings raw_initial_config;
+
+void raw_idt_notify()
+{
+  printk("raw_idt_notify has been called \n");
+}
+
+void  rtems_irq_mngt_init()
+{
+    int 			i;
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+    unsigned int 		level;
+
+    
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+    
+    _CPU_ISR_Disable(level);
+
+    /*
+     * Init the complete IDT vector table with defaultRawIrq value
+     */
+    for (i = 0; i < IDT_SIZE; i++) {
+      idtHdl[i] = defaultRawIrq;
+    }
+    raw_initial_config.idtSize = IDT_SIZE;
+    raw_initial_config.defaultRawEntry = defaultRawIrq;
+    raw_initial_config.rawIrqHdlTbl = idtHdl;
+    
+    if (!i386_init_idt (&raw_initial_config)) {
+      /*
+       * put something here that will show the failure...
+       */
+      _IBMPC_initVideo();
+      printk("Unable to initialize IDT!!! System locked\n");
+      while (1);
+    }
+    /*
+     * Patch the entry that will be used by RTEMS for interrupt management
+     * with RTEMS prologue.
+     */
+    for (i = 0; i < PC_386_IRQ_LINES_NUMBER; i++) {
+      create_interrupt_gate_descriptor(&idtEntry,(rtems_raw_irq_hdl) rtemsIrq[i].hdl);
+      idt_entry_tbl[i + PC386_ASM_IRQ_VECTOR_BASE] = idtEntry;
+    }
+    /*
+     * At this point we have completed the initialization of IDT
+     * with raw handlers.  We must now initialize the higher level
+     * interrupt management.
+     */
+    /*
+     * re-init the rtemsIrq table
+     */
+    for (i = 0; i < PC_386_IRQ_LINES_NUMBER; i++) {
+      rtemsIrq[i] = defaultIrq;
+    }
+    /*
+     * Init initial Interrupt management config
+     */
+    initial_config.irqNb 	= PC_386_IRQ_LINES_NUMBER;
+    initial_config.defaultEntry = defaultIrq;
+    initial_config.irqHdlTbl	= rtemsIrq;
+    initial_config.irqBase	= PC386_ASM_IRQ_VECTOR_BASE;
+    initial_config.irqPrioTbl	= irqPrioTable;
+    if (!pc386_rtems_irq_mngt_set(&initial_config)) {
+      /*
+       * put something here that will show the failure...
+       */
+      _IBMPC_initVideo();
+      printk("Unable to initialize RTEMS interrupt Management!!! System locked\n");
+      while (1);
+    }
+
+#define DEBUG    
+#ifdef DEBUG
+    {
+      /*
+       * following adresses should be the same
+       */
+      unsigned tmp;
+
+      _IBMPC_initVideo();
+      
+      printk("idt_entry_tbl =  %x Interrupt_descriptor_table addr = %x\n",
+	     idt_entry_tbl, &Interrupt_descriptor_table);
+      tmp = (unsigned) get_hdl_from_vector (PC386_ASM_IRQ_VECTOR_BASE + PC_386_PERIODIC_TIMER);
+      printk("clock isr address from idt = %x should be %x\n",
+	     tmp, (unsigned) rtems_irq_prologue_0);
+    }
+    printk("i8259s_cache = %x\n", * (unsigned short*) &i8259s_cache);
+    debugPollingGetChar();
+#endif    
+    asm volatile ("sti");
+}
Index: c/src/lib/libcpu/i386/cpu.c
===================================================================
--- c/src/lib/libcpu/i386/cpu.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
+++ c/src/lib/libcpu/i386/cpu.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -0,0 +1,265 @@
+/*
+ * cpu.c  - This file contains implementation of C function to
+ *          Instanciate IDT entries. More detailled information can be found
+ *	    on Intel site and more precisely in the following book :
+ *
+ *		Pentium Processor familly
+ *		Developper's Manual
+ *
+ *		Volume 3 : Architecture and Programming Manual
+ *
+ * Copyright (C) 1998  Eric Valette (valette@crf.canon.fr)
+ *                     Canon Centre Recherche France.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ * $Id$
+ */
+
+#include <libcpu/cpu.h>
+#include <irq.h>
+
+static rtems_raw_irq_connect_data* 	raw_irq_table;
+static rtems_raw_irq_connect_data  	default_raw_irq_entry;
+static interrupt_gate_descriptor   	default_idt_entry;
+static rtems_raw_irq_global_settings* 	local_settings;
+
+void create_interrupt_gate_descriptor (interrupt_gate_descriptor* idtEntry,
+				       rtems_raw_irq_hdl hdl)
+{
+    idtEntry->low_offsets_bits	= (((unsigned) hdl) & 0xffff);
+    idtEntry->segment_selector	= i386_get_cs(); 
+    idtEntry->fixed_value_bits	= 0;
+    idtEntry->gate_type		= 0xe; 
+    idtEntry->privilege		= 0;
+    idtEntry->present		= 1;
+    idtEntry->high_offsets_bits	= ((((unsigned) hdl) >> 16) & 0xffff);
+}
+
+rtems_raw_irq_hdl get_hdl_from_vector(rtems_vector_offset index)
+{
+    rtems_raw_irq_hdl		hdl;
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+  
+    * ((unsigned int*) &hdl) = (idt_entry_tbl[index].low_offsets_bits | 
+			      (idt_entry_tbl[index].high_offsets_bits << 16));
+    return hdl;
+}
+
+int i386_set_idt_entry  (const rtems_raw_irq_connect_data* irq)
+{
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+    unsigned int 		level;
+
+    
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+
+    if (irq->idtIndex > limit) {
+      return 0;
+    }
+    /*
+     * Check if default handler is actually connected. If not issue an error.
+     * You must first get the current handler via i386_get_current_idt_entry
+     * and then disconnect it using i386_delete_idt_entry.
+     * RATIONALE : to always have the same transition by forcing the user
+     * to get the previous handler before accepting to disconnect.
+     */
+    if (get_hdl_from_vector(irq->idtIndex) != default_raw_irq_entry.hdl) {
+      return 0;
+    }
+    _CPU_ISR_Disable(level);
+    
+    raw_irq_table [irq->idtIndex] = *irq;
+    create_interrupt_gate_descriptor (&idt_entry_tbl[irq->idtIndex], irq->hdl);
+    irq->on(irq);
+    
+    _CPU_ISR_Enable(level);
+    return 1;
+}
+
+void _CPU_ISR_install_vector (unsigned vector,
+			      void* hdl,
+			      void** oldHdl)
+{
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+    interrupt_gate_descriptor	new;
+    unsigned int 		level;
+    
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+
+    if (vector > limit) {
+      return;
+    }
+    _CPU_ISR_Disable(level)
+    * ((unsigned int *) oldHdl) = idt_entry_tbl[vector].low_offsets_bits |
+	(idt_entry_tbl[vector].high_offsets_bits << 16);
+
+    create_interrupt_gate_descriptor(&new,  hdl);
+    idt_entry_tbl[vector] = new;
+
+    _CPU_ISR_Enable(level);
+}
+				
+int i386_get_current_idt_entry (rtems_raw_irq_connect_data* irq)
+{
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+
+    if (irq->idtIndex > limit) {
+      return 1;
+    }
+    raw_irq_table [irq->idtIndex].hdl = get_hdl_from_vector(irq->idtIndex);
+    
+    *irq = raw_irq_table [irq->idtIndex];
+    
+    return 0;
+}
+
+int i386_delete_idt_entry (const rtems_raw_irq_connect_data* irq)
+{
+    interrupt_gate_descriptor* 	idt_entry_tbl;
+    unsigned			limit;
+    unsigned int 		level;
+    
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+
+    if (irq->idtIndex > limit) {
+      return 1;
+    }
+     /*
+     * Check if handler passed is actually connected. If not issue an error.
+     * You must first get the current handler via i386_get_current_idt_entry
+     * and then disconnect it using i386_delete_idt_entry.
+     * RATIONALE : to always have the same transition by forcing the user
+     * to get the previous handler before accepting to disconnect.
+     */
+    if (get_hdl_from_vector(irq->idtIndex) != irq->hdl){
+      return 1;
+    }
+    _CPU_ISR_Disable(level);
+
+    idt_entry_tbl[irq->idtIndex] = default_idt_entry;
+
+    irq->off(irq);
+    
+    raw_irq_table[irq->idtIndex] = default_raw_irq_entry;
+
+    _CPU_ISR_Enable(level);
+    
+    return 0;
+}
+
+/*
+ * Caution this function assumes the IDTR has been already set.
+ */
+int i386_init_idt (rtems_raw_irq_global_settings* config)
+{
+    unsigned			limit;
+    unsigned 			i;
+    unsigned 			level;
+    interrupt_gate_descriptor*	idt_entry_tbl;
+    
+    i386_get_info_from_IDTR (&idt_entry_tbl, &limit);
+
+      
+    if (config->idtSize != limit) {
+      return 1;
+    }
+    /*
+     * store various accelarators
+     */
+    raw_irq_table 		= config->rawIrqHdlTbl;
+    local_settings 		= config;
+    default_raw_irq_entry 	= config->defaultRawEntry;
+
+    _CPU_ISR_Disable(level);
+
+    create_interrupt_gate_descriptor (&default_idt_entry, default_raw_irq_entry.hdl);
+
+    for (i=0; i < limit; i++) {
+      interrupt_gate_descriptor new;
+      create_interrupt_gate_descriptor (&new, raw_irq_table[i].hdl);
+      idt_entry_tbl[i] = new;
+      if (raw_irq_table[i].hdl != default_raw_irq_entry.hdl) {
+	raw_irq_table[i].on(&raw_irq_table[i]);
+      }
+      else {
+	raw_irq_table[i].off(&raw_irq_table[i]);
+      }
+    }
+    _CPU_ISR_Enable(level);
+
+    return 0;
+}
+
+int i386_get_idt_config (rtems_raw_irq_global_settings** config)
+{
+  *config = local_settings;
+  return 0;
+}
+
+/*
+ * Caution this function assumes the GDTR has been already set.
+ */
+int i386_set_gdt_entry (unsigned short segment_selector, unsigned base,
+			unsigned limit)
+{
+    unsigned 			gdt_limit;
+    unsigned short              tmp_segment = 0;
+    unsigned int                limit_adjusted;
+    segment_descriptors* 	gdt_entry_tbl;
+
+      
+    i386_get_info_from_GDTR (&gdt_entry_tbl, &gdt_limit);
+
+    if (segment_selector > limit) {
+      return 1;
+    }
+    /*
+     * set up limit first
+     */
+    limit_adjusted = limit;
+    if ( limit > 4095 ) {
+      gdt_entry_tbl[segment_selector].granularity = 1;
+      limit_adjusted /= 4096;
+    }
+    gdt_entry_tbl[segment_selector].limit_15_0  = limit_adjusted & 0xffff;
+    gdt_entry_tbl[segment_selector].limit_19_16 = (limit_adjusted >> 16) & 0xf;
+    /*
+     * set up base
+     */
+    gdt_entry_tbl[segment_selector].base_address_15_0  = base & 0xffff;
+    gdt_entry_tbl[segment_selector].base_address_23_16 = (base >> 16) & 0xff;
+    gdt_entry_tbl[segment_selector].base_address_31_24 = (base >> 24) & 0xff;
+    /*
+     * set up descriptor type (this may well becomes a parameter if needed)
+     */
+    gdt_entry_tbl[segment_selector].type 		= 2;   	/* Data R/W */
+    gdt_entry_tbl[segment_selector].descriptor_type 	= 1;	/* Code or Data */
+    gdt_entry_tbl[segment_selector].privilege 		= 0; 	/* ring 0 */
+    gdt_entry_tbl[segment_selector].present 		= 1; 	/* not present */
+
+    /*
+     * Now, reload all segment registers so the limit takes effect.
+     */
+
+    asm volatile( "movw %%ds,%0 ; movw %0,%%ds
+                   movw %%es,%0 ; movw %0,%%es
+                   movw %%fs,%0 ; movw %0,%%fs
+                   movw %%gs,%0 ; movw %0,%%gs
+                   movw %%ss,%0 ; movw %0,%%ss"
+                   : "=r" (tmp_segment)
+                   : "0"  (tmp_segment)
+		  );
+    
+    return 0;
+}
